#
# spec file for package db42 (Version 4.2.52)
#
# Copyright (c) 2006 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild
# usedforbuild    aaa_base acl attr audit-libs autoconf automake bash bind-libs bind-utils binutils bison bzip2 coreutils cpio cpp cpp41 cracklib cvs cyrus-sasl db diffutils e2fsprogs ed file filesystem fillup findutils flex gawk gcc gcc-c++ gcc41 gcc41-c++ gdbm gdbm-devel gettext gettext-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv klogd less libacl libattr libcom_err libgcc41 libltdl libmudflap41 libnscd libstdc++41 libstdc++41-devel libtool libvolume_id libxcrypt libzio linux-kernel-headers m4 make man mktemp module-init-tools ncurses ncurses-devel net-tools netcfg openldap2-client openssl pam pam-modules patch perl permissions popt procinfo procps psmisc pwdutils rcs readline rpm sed strace sysvinit tar tcpd texinfo timezone unzip util-linux vim zlib zlib-devel

Name:           db42
BuildRequires:  ed gcc-c++
Summary:        Berkeley DB Database Library Version 4.2
Version:        4.2.52
Release:        38
Source:         db-%{version}.tar.bz2
Patch:          db-%{version}.dif
Patch1:         patch.%{version}.1
Patch2:         patch.%{version}.2
Patch3:         db-%{version}-ppc.patch
Patch4:         db-%{version}-disable_hardcoding_paths_into_libs.patch
URL:            http://www.sleepycat.com
License:        BSD License and BSD-like
Group:          System/Libraries
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
Prefix:         %{_prefix}

%description
The Berkeley DB Database is a programmatic toolkit that provides
database support for applications.

This package contains the necessary runtime libraries for the old 4.2
release.



%debug_package
%package devel
Summary:        Berkeley DB database library Version 4.2
Group:          System/Libraries
Prefix:         %{_prefix}
Requires:       db42 = %{version} glibc-devel

%description devel
The Berkeley DB Database is a programmatic toolkit that provides
database support for applications.

This package contains the necessary runtime libraries for the old 4.2
release.



%prep
%setup -q -n db-%{version}
%patch
%patch1
%patch2
%patch3
%patch4

%build
cd dist
./s_config
CFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing"
CXXFLAGS="$CFLAGS"
CC=gcc
export CFLAGS CXXFLAGS CC
#
# Build now the NPTL version
#
mkdir ../build_nptl
cd ../build_nptl
../dist/configure --prefix=%{_prefix} \
        --libdir=%{_libdir} --enable-compat185 --disable-dump185 \
        --enable-shared --enable-static --enable-rpc --enable-cxx \
	--with-mutex="POSIX/pthreads/library" \
        %{_target_cpu}-suse-linux
# Make sure O_DIRECT is really disabled (build host could have old kernel)
perl -pi -e 's/#define HAVE_O_DIRECT 1/#undef HAVE_O_DIRECT/' db_config.h
# Remove libtool predep_objects and postdep_objects wonkiness
perl -pi -e 's/^predep_objects=".*$/predep_objects=""/' libtool
perl -pi -e 's/^postdep_objects=".*$/postdep_objects=""/' libtool
perl -pi -e 's/-shared -nostdlib/-shared/' libtool
make LIBSO_LIBS='$(LIBS)' LIBXSO_LIBS='$(LIBS)'" -L%{_libdir} -lstdc++"

%install
rm -rf ${RPM_BUILD_ROOT}
mkdir -p ${RPM_BUILD_ROOT}%{_includedir}/db42
mkdir -p ${RPM_BUILD_ROOT}%{_prefix}/%{_lib}
cd build_nptl
make prefix=${RPM_BUILD_ROOT}%{_prefix} libdir=${RPM_BUILD_ROOT}%{_libdir} install
cd ..
# make ldd happy:
chmod 755 $RPM_BUILD_ROOT%{_libdir}/libdb*.so
# Fix header file installation
mv ${RPM_BUILD_ROOT}%{_includedir}/*.h ${RPM_BUILD_ROOT}%{_includedir}/db42
# Move documentation to the right directory
mkdir -p $RPM_BUILD_ROOT%{_defaultdocdir}/db42
mv $RPM_BUILD_ROOT%{_prefix}/docs/* $RPM_BUILD_ROOT/%{_defaultdocdir}/db42/
cp -a LICENSE README $RPM_BUILD_ROOT/%{_defaultdocdir}/db42/
# Remove stuff we don't wish any longer:
rm -rfv $RPM_BUILD_ROOT/%{_defaultdocdir}/db42/{utility,ref,java,api_*}
rm -fv $RPM_BUILD_ROOT%{_bindir}/*
rm -fv $RPM_BUILD_ROOT%{_libdir}/{libdb.a,libdb_cxx.a}
rm -fv $RPM_BUILD_ROOT%{_libdir}/tls/{libdb.a,libdb_cxx.a}
# Remove crappy *.la files
rm -fv $RPM_BUILD_ROOT%{_libdir}/*.la
rm -fv $RPM_BUILD_ROOT%{_libdir}/tls/*.la
rm -f $RPM_BUILD_ROOT/%{_libdir}/libdb-4.so
rm -f $RPM_BUILD_ROOT/%{_libdir}/libdb.so
rm -f $RPM_BUILD_ROOT/%{_libdir}/libdb_cxx-4.so
rm -f $RPM_BUILD_ROOT/%{_libdir}/libdb_cxx.so

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%clean
rm -rf ${RPM_BUILD_ROOT}

%files
%defattr(-,root,root)
%dir %{_defaultdocdir}/db42
%doc %{_defaultdocdir}/db42/LICENSE
%doc %{_defaultdocdir}/db42/README
%doc %{_defaultdocdir}/db42/index.html
%doc %{_defaultdocdir}/db42/images
%doc %{_defaultdocdir}/db42/sleepycat
%{_libdir}/libdb-4.2.so
%{_libdir}/libdb_cxx-4.2.so

%files devel
%defattr(-,root,root)
%dir %{_includedir}/db42
%{_includedir}/db42/db.h
%{_includedir}/db42/db_185.h
%{_includedir}/db42/db_cxx.h
%{_libdir}/libdb-4.2.a
%{_libdir}/libdb_cxx-4.2.a

%changelog -n db42
* Wed Feb 01 2006 - dbornkessel@suse.de
- make libtool avoid hardcoding RPATHs in shared libs
* Wed Jan 25 2006 - mls@suse.de
- converted neededforbuild to BuildRequires
* Mon Dec 19 2005 - ro@suse.de
- remove unpackaged symlinks from build root
* Mon Oct 24 2005 - kukuk@suse.de
- libtool is crap
* Thu Oct 20 2005 - kukuk@suse.de
- Remove LinuxThreads support
* Wed Jul 13 2005 - kukuk@suse.de
- Fix building without LinuxThreads
* Thu Nov 18 2004 - kukuk@suse.de
- Make a compat package from it and rename it to db42
* Fri Sep 10 2004 - kukuk@suse.de
- i586 now also has NPTL support
* Mon May 10 2004 - kukuk@suse.de
- Add libtool workaround to always get a soname [Bug #39128]
* Thu Mar 25 2004 - kukuk@suse.de
- Add a locking fix for replication clients
* Wed Mar 24 2004 - meissner@suse.de
- Slightly adjusted ppc locking to use isync at
  the right place.
- actually apply Thorstens last patch.
* Mon Jan 12 2004 - kukuk@suse.de
- Add patch to fix problem with long-running applications
  hanging in DB cache.
* Mon Jan 12 2004 - kukuk@suse.de
- Add/Remove nptl libraries to/from ldconfig cache
* Tue Dec 16 2003 - kukuk@suse.de
- Fix libtool.ac for AMD64
- Fix mutex.ac for MIPS
* Mon Dec 15 2003 - kukuk@suse.de
- Update to version 4.2.52
- Disable MIPS patch temporary
* Tue Dec 09 2003 - kukuk@suse.de
- Add s390 as NPTL architecture
* Thu Nov 27 2003 - kukuk@suse.de
- Fix linking of libdb_cxx.so
* Mon Nov 24 2003 - kukuk@suse.de
- Link non-NPTL libdb on NPTL archs against pthread library, too
* Fri Nov 21 2003 - kukuk@suse.de
- Remove old, unused patches
- Compile with no-execstack
- Add db linked against nptl pthread library
* Fri Oct 17 2003 - adrian@suse.de
- revert last change and implement fast mutexes for mips
  (partly taken from linux kernel source)
* Wed Oct 15 2003 - adrian@suse.de
- use posixmutexes on mips
* Wed Oct 15 2003 - kukuk@suse.de
- Build as non root
* Thu Oct 02 2003 - kukuk@suse.de
- Remove ed from needed for build
* Fri Sep 26 2003 - kukuk@suse.de
- Disable db_dump185
- Enable compiler warnings
- Disable strict aliasing
* Mon Jun 23 2003 - meissner@suse.de
- PPC needs isync after bne or it might break on SMP systems
  and lwsync (sync all previous memory operations) on unset.
* Mon May 12 2003 - kukuk@suse.de
- Add examples_{c,cxx} to devel filelist
* Thu May 08 2003 - kukuk@suse.de
- Update to 4.1.25
* Thu Jan 23 2003 - bg@suse.de
- Fix mutex support for hppa
  (patch by Keith Bostic, bostic@sleepycat.com)
* Thu Jan 09 2003 - kukuk@suse.de
- Add db4-4.0.14-recover.patch: fix endless loop with db_recover
* Mon Sep 16 2002 - rhafer@suse.de
- Added locker-leak-fix.dif, which fixes a resource leak triggerd
  by openldap2 and larger databases. For more details see:
  www.openldap.org/its/index.cgi/Software%%20Bugs?id=2040
* Sat Aug 31 2002 - schwab@suse.de
- Fix last libstdc++ change for real.
* Fri Aug 30 2002 - kukuk@suse.de
- Fix last libstdc++ change
* Tue Aug 27 2002 - pthomas@suse.de
- Explicitely link libdb_cxx against libstdc++. This is a hack
  until libtool 1.4e is released.
- Directly pass RPM_OPT_FLAGS as CFLAGS and CXXFLAGS.
* Thu Jul 25 2002 - rhafer@suse.de
- fix for mutex support on s390 (by bk@suse.de)
- rebuild configure script during build (using s_conf)
* Wed Jul 03 2002 - uli@suse.de
- added mutex support for x86-64
* Fri May 10 2002 - kukuk@suse.de
- Add patch to fix missing mutex support on Alpha, SPARC and s390
* Fri May 03 2002 - kukuk@suse.de
- correct calculation of needed space for shalloc [Bug #12096]
* Mon Jan 21 2002 - kukuk@suse.de
- Update to db 4.0.14
- put all documenation into /usr/share/doc/packages/db, so html
  index works.
* Thu Nov 15 2001 - ro@suse.de
- added patch 3.3.11.1
  Fix a bug in DB 1.85 compatibility mode that could cause
  DB 1.85 applications to fail to compile
* Mon Nov 05 2001 - adrian@suse.de
- update to 3.3.11
- move optional documentation to db-extensions-devel package
* Fri Jul 20 2001 - kukuk@suse.de
- Fix build on multilib archs
* Wed Jun 06 2001 - bk@suse.de
- add suse_update_config for s390x
* Wed May 09 2001 - mfabian@suse.de
- bzip2 sources
* Sat Mar 31 2001 - schwab@suse.de
- Build static and shared libraries in one go.
* Mon Nov 06 2000 - kukuk@suse.de
- Add /usr/include/db_185.h and /usr/include/db_cxx.h
* Wed Oct 25 2000 - kukuk@suse.de
- Install static library versions, too
* Sat Oct 21 2000 - kukuk@suse.de
- Fix documentation
- Add /usr/include/db.h
* Wed Oct 18 2000 - kukuk@suse.de
- initial version
